#import "../CoverSlide.h"
#import <Foundation/NSBundle.h>
#import <AppKit/psops.h>
#import "../FullScreenView.h"
#import "../FullScreenWindow.h"
#import "../PrefCtrl.h"
#import "../commtypes.h"
#import <Foundation/NSAutoreleasePool.h>  // Debug

#define  CoverName	@"cover"
#define  CoverImage	@"cover.tiff"
#define  OpenStepImg	@"PoweredByOPENSTEP.tiff"
#define  IconAppImg	@"IconApp.tiff"

@implementation CoverSlide

- (id)initForCoverSheet
{
	NSString *s;

	[self init];
	[backView setController:self];
	// [backView setBackgroundColor:setting->bgcolor];
	s = [[NSBundle mainBundle] pathForResource:CoverName ofType:@"tiff"];
	[self setOHPPath:[s stringByDeletingLastPathComponent]];
	return self;
}

- (void)coverSheet:(id)sender
{
	NSString	*fn;
	NSImage		*img, *icon, *showImage;
	NSSize		sz, scsz;
	float		x, y, w;
	NSPoint		pt;

	id pool = [[NSAutoreleasePool alloc] init];	// ####
	fn = [ohpPath stringByAppendingPathComponent:CoverImage];
	img = [[NSImage alloc] initWithContentsOfFile:fn];
	[img setScalesWhenResized:YES];
	[backView makeBackground:img method:bk_CoverScreen];
	[backView drawBackground];
	[img release];

	showImage = [backView image];
	scsz = scrRect.size;
	fn = [ohpPath stringByAppendingPathComponent:OpenStepImg];
	img = [[NSImage alloc] initWithContentsOfFile:fn];
	[img setScalesWhenResized:YES];
	sz = [img size];
	w = scsz.width * 0.0012;
	sz.width = (int)(sz.width * w);
	sz.height = (int)(sz.height * w);
	[img setSize:sz];
	fn = [ohpPath stringByAppendingPathComponent:IconAppImg];
	icon = [[NSImage alloc] initWithContentsOfFile:fn];
	[icon setScalesWhenResized:YES];
	sz = [icon size];
	w = scsz.width * 0.004;
	sz.width = (int)(sz.width * w);
	sz.height = (int)(sz.height * w);
	[icon setSize:sz];

	[showImage lockFocus];	/************ lockFocus *************/
	pt.x = scsz.width * 0.12;
	pt.y = scsz.height * 0.63;
	[icon compositeToPoint:pt operation:NSCompositeSourceOver];
	pt.x = scsz.width * 0.1;
	pt.y = scsz.height * 0.08;
	[img compositeToPoint:pt operation:NSCompositeSourceOver];

	PSsetgray(0.0);
	PSsetlinewidth(2.0);
	PSrectstroke(6.0, 6.0, scsz.width - 12.0, scsz.height - 12.0);
	PSrectstroke(10.0, 10.0, scsz.width - 20.0, scsz.height - 20.0);
	PSsetlinewidth(1.0);
	PSrectstroke(13.0, 14.0, scsz.width - 27.0, scsz.height - 27.0);
	PSrectstroke(15.0, 16.0, scsz.width - 31.0, scsz.height - 31.0);

	PSselectfont("Times-Roman", scsz.width / 10.0);
	PSmoveto(scsz.width / 3.0, scsz.height * 0.6889);
	PSsetgray(1.0);
	PSshow("ToyProjector");
	w = scsz.width / 200.0;
	PSmoveto(scsz.width / 3.0 - w, scsz.height * 0.6889 + w);
	PSsetgray(0.0);
	PSshow("ToyProjector");
	PSselectfont("Helvetica-Oblique", scsz.width / 28.0);
	PSmoveto(scsz.width * 0.5, scsz.height * 0.6);
	PSshow("by Takeshi Ogihara");
	PSmoveto(scsz.width / 3.0, scsz.height * 0.6);
	PSshow(CurrentVERSION);

	w = scsz.height * 0.16;
	PSsetrgbcolor(0, 1, 0);
	x = scsz.width * 0.36;
	y = scsz.height * 0.29;
	PSrectfill(x, y, w, w);
	PSsetgray(0.0);
	PSrectstroke(x, y, w, w);
	PSsetrgbcolor(1, 0, 0);
	x = scsz.width * 0.43;
	y = scsz.height * 0.22;
	PSrectfill(x, y, w, w);
	PSsetgray(0.0);
	PSrectstroke(x, y, w, w);
	PSsetrgbcolor(0, 0, 1);
	x = scsz.width * 0.53;
	y = scsz.height * 0.27;
	PSrectfill(x, y, w, w);
	PSsetgray(0.0);
	PSrectstroke(x, y, w, w);

	[showImage unlockFocus];  /************ unlockFocus *************/
	[img release];
	[icon release];
	[backWin makeKeyAndOrderFront:self];
	[backWin display];
	[pool release];					// ####
}

- (void)nextPush:(id)sender {	[self quitPush:sender];	}
- (void)prevPush:(id)sender {	[self quitPush:sender];	}

@end
