#import <AppKit/AppKit.h>

@class NSString;

@interface FileSelector : NSObject
{
	id	browser;
	id	panel;
	id	iconView;
	id	iconText;
	id	scenario;	/* refer only */
	NSString *rootPath;
	NSString *cwd;
	int	cwdCol;
}

- (void)dealloc;
- (void)activateAndOrderFront:(id)sender;
- (void)setScenarioCtrl:(id)newScenario;

- (BOOL)setPath:(NSString *)path;
- (void)addSelectedFile:(id)sender;
- (void)deletePushed:(id)sender;
- (void)redisplay:(id)sender;

/* Browser's Action */
- (void)fileSelected:(id)sender;
- (void)fileDoubleClicked:(id)sender;

/* Browser's Delegate */
- (void)browser:(NSBrowser *)sender createRowsForColumn:(int)column inMatrix:(NSMatrix *)matrix;

/* ICON VIEW METHODS */
- (BOOL)iconReleased:(id)sender data:(NSArray *)plist;

/* NSWinodow's Delegate */
- (BOOL)windowShouldClose:(id)sender;

@end
