#import <AppKit/NSView.h>

@class NSEvent, NSImage, NSColor;

@interface FullScreenView: NSView
{
	 NSImage *showImage;
	 NSImage *backImage;
	 NSColor *backgroundColor;
	 id	controller;
	 NSRect	rectL, rectP;
}

+ (void)initialize;

/* OverWrite */
- (id)initWithFrame:(NSRect)frameRect;
- (void)dealloc;
- (BOOL)acceptsFirstMouse:(NSEvent *)theEvent;
- (BOOL)becomeFirstResponder;

- (void)setController:(id)obj;
- (NSColor *)backgroundColor;
- (void)setBackgroundColor:(NSColor *)clr;
- (NSImage *)image;
- (void)drawBackground;
- (double)enlargeScale:(NSSize)imgsz by:(int)method err:(int *)err;
- (void)makeBackground:(NSImage *)image method:(int)method;
- (void)drawCopy:(NSImage *)img;
- (void)drawSover:(NSImage *)img;
- (void)drawMark:(int)coloridx;
- (void)drawRect:(NSSize)sz withColor:(NSColor *)clr andTransp:(float)trans;
- (void)drawImage:(NSImage *)img at:(NSPoint)pnt
	withBackground:(NSColor *)bgclr transparent:(float)trans;
- (void)resetCursorRects;
- (void)mouseDown:(NSEvent *)event;
- (void)keyDown:(NSEvent *)event;
- (void)drawRect:(NSRect)rect;

@end
