#import "FullScreenWindow.h"
#import <AppKit/NSView.h>
#import <AppKit/NSScreen.h>

#define  WLevel_Front	(NSMainMenuWindowLevel+5)


@implementation FullScreenWindow

/* OverWrite */
- (NSRect)constrainFrameRect:(NSRect)frameRect toScreen:(NSScreen *)aScreen
{
	return frameRect;
}
/* This class ignore constrainFrameRect:toScreen: method not to display
   title bars of windows.  A window should have a title bar to be a key
   window.
*/


/* OverWrite */
- (void)makeKeyAndOrderFront:(id)sender
{
	[self setLevel: WLevel_Front];
	[self orderWindow:NSWindowAbove relativeTo:0];
	[super makeKeyAndOrderFront:sender];
}

- (id)initWithView:(NSView *)view
{
	NSPoint p;
	NSRect rect;
	NSSize scSize;

	rect = [view frame];
        [self initWithContentRect:rect styleMask:NSTitledWindowMask
		backing:NSBackingStoreBuffered
		defer:NO];
	[self setContentView:view];
	[self useOptimizedDrawing:YES];
	[self setAcceptsMouseMovedEvents:NO];
	[self invalidateCursorRectsForView:view];
			/* To reset the shapes of cursor on the view */
	scSize = [[NSScreen mainScreen] frame].size;
#ifdef __APPLE__	/* Mac OS X Server */
	p.x = -7.0;
	p.y = scSize.height - rect.size.height - 8.0;
	/* 8.0 = width of border line + Title "Line" for emergency */
#else
	p.x = -1.0;
	p.y = scSize.height - rect.size.height - 2.0;
	/* 2.0 = width of border line + Title "Line" for emergency */
#endif
	[self setFrameOrigin:p];
	return self;
}

@end
