#import "NSColorAdditional.h"
#import <Foundation/NSArray.h>
#import <Foundation/NSString.h>

@implementation NSColor (Additional)

+ (id)colorWithRGBElements:(unsigned char *)ar
{
	return [self colorWithCalibratedRed:(float)ar[0]/255.0
		green:(float)ar[1]/255.0 blue:(float)ar[2]/255.0 alpha:1.0];
}

+ (id)colorWithRGBArray:(NSArray *)ar
{
	int	i;
	unsigned char	backg[3];

	if (ar == nil || [ar count] < 3)
		return nil;
	for (i = 0; i < 3; i++)
		backg[i] = [[ar objectAtIndex: i] intValue];
	return [self colorWithRGBElements: backg];
}

+ (id)colorFor:(NSArray *)ar default:(unsigned char *)defs
{
	if (ar == nil || [ar count] < 3)
		return [self colorWithRGBElements: defs];
	return [self colorWithRGBArray: ar];
}

+ (NSMutableArray *)arrayWithRGBColors:(unsigned char *)rgb
{
	int i;
	NSMutableArray *ar = [NSMutableArray arrayWithCapacity: 3];
	for (i = 0; i < 3; i++)
		[ar addObject:[NSString stringWithFormat:@"%d", rgb[i]]];
	return ar;
}

- (NSMutableArray *)RGBArrayForColor
{
	NSMutableArray *ar;
	int	i, v;
	float	buf[4];

	[[self colorUsingColorSpaceName:NSCalibratedRGBColorSpace]
		getRed:&buf[0] green:&buf[1] blue:&buf[2] alpha:NULL];
	ar = [NSMutableArray arrayWithCapacity: 3];
	for (i = 0; i < 3; i++) {
		v = buf[i] * 255.0;
		[ar addObject:[NSString stringWithFormat:@"%d", v]];
	}
	return ar;
}

@end
