/*
 * Created by Stone Design's Create on 4/30/1998
 */
/* SDMovingRowsProtocol.h created by andrew on Thu 26-Mar-1998 */


@protocol SDMovingRowsProtocol

// Which key modifiers enable reordering? OR them together
// exp: return (NSCommandKeyMask|NSAlternateKeyMask);
// if you want the default behaviour to alas drag cells
// pass this pack for

#define DRAG_ALWAYS    0
- (unsigned int)dragReorderingMask:(int)forColumn;

// Delegate called after the reordering of cells, you must reorder your data.
// Returning YES will cause the table to be reloaded.
- (BOOL)tableView:(NSTableView *)tv didDepositRow:(int)rowToMove at:(int)newPosition;

// Notifies the delegate of impending movement
- (void)willMoveRow:(int)row;

// When we move an image around in the reordering process
// we'll use this method to get the correct image:
// - (NSImage *)imageForRow:(int)row;

// This gives you a chance to decline to drop particular rows on other
// particular row. Return YES if you don't care
- (BOOL) tableView:(NSTableView *)tableView draggingRow:(int)draggedRow overRow:(int) targetRow;

@end
