/*
 * Andrew@stone.com
 * http://www.stone.com/GIFfun/GIFfun-source.tar.gz
 *	Slightly modified by T.Ogihara
 */

#import <AppKit/AppKit.h>

@interface SDTableView : NSTableView
{
    BOOL needsControlKey;	// YES if the user needs to hold the control key
                                // to instigate dragging
    BOOL constrainedMove;	// YES if the user wants to constrain the row to
                                // the view
    BOOL hasHeader;
    int draggedRow;
    NSImage *rowCache;
    NSImage *tableCache;
}

- (void)setConstrainedMove:(BOOL)flag;
- (void)setNeedsControlKey:(BOOL)flag;
- (void)setHasHeader:(BOOL)flag;
/* Overwrite to scroll automatically */
- (void)selectRow:(int)rowIndex byExtendingSelection:(BOOL)flag;

/* Active Methods for Editing */
- (void)copy:(id)sender;
- (void)paste:(id)sender;
- (void)cut:(id)sender;
- (void)delete:(id)sender;

@end


@interface NSObject(SDTableViewDelegate)

- (BOOL) tableView:(SDTableView *)tableView rowWillMove:(int)draggedRow;
- (NSImage *)tableView:(SDTableView *)tableView imageForRow:(int)aRow;
- (BOOL) tableView:(SDTableView *)tableView willDepositRow:(int) rowToMove at:(int) newPosition;

@end