#import <AppKit/AppKit.h>
#import "SettingDictionary.h"

@class NSArray, NSString, NSNotification;

@interface ScenarioCtrl : NSObject
{
	id	window;
	id	table;
	id	source;
	id	controller;
	id	selector;
	id	settingCtrl;
	id	slideshow;
	BOOL	fileDeletable;
	struct setinfo	*setting;
	NSString *filepath;
}

+ (void)initialize;
- (void)loadNib;
- (void)dealloc;
- (BOOL)setAndCreateDir:(NSString *)fn;
- (BOOL)setAndOpenDoc:(NSString *)fn;
- (void)save;
- (void)saveIfNeeded;
- (void)saveAs:(NSString *)newname;
- (void)delete:(id)sender;
- (void)reload;
- (void)tableDidChange:(NSNotification *)notification;
- (void)settingChanged:(id)sender;
- (void)addFiles:(NSArray *)flist;
- (void)openFileByWS:(NSString *)fn;
- (void)quitShow;
- (void)appShouldQuit;
- (NSString *)filename;
- (id)window;
- (void)makeKeyAndOrderFront:(id)sender;
- (void)setController:(id)obj;
- (void)activateInspector:(id)sender;
- (void)activateSelector:(id)sender;
- (void)activateSettingCtrl:(id)sender;
- (void)checkFileList:(id)sender;

- (void)saveScenario:(id)sender;

- (void)start:(id)sender;

/* NSWinodow's Delegate */
- (BOOL)windowShouldClose:(id)sender;
- (void)windowDidBecomeMain:(NSNotification *)aNotification;

@end
