/* Based on the protocol "NSTableDataSource" */
#import <AppKit/NSTableView.h>
#import <AppKit/NSTableColumn.h>
#import "SDMovingRowsProtocol.h"

#define  ScenarioDidChange	@"ScenarioDidChange"

@class NSArray, NSMutableArray;

@interface ScenarioSource : NSObject <SDMovingRowsProtocol>
{
	NSMutableArray *records;
	id		controller;	/* just refering */
}

- (id)init;
- (void)setController:(id)ctrl;
- (unsigned)count;
- (void)castNotification;
- (int)addFiles:(NSArray *)flist inDir:(NSString *)dir fromIndex:(int)row;
- (void)removeAtIndex:(int)num;
- (int)checkFileExistence;
- (void)doubleClicked:(id)sender;
- (NSArray *)fileListUsed;
- (void)insertDirectoryElement:(NSString *)dir;

- (BOOL)writeToFile:(NSString *)fpath with:(id)setting;
- (id)readFromFile:(NSString *)fpath;

/* Used from Inspector & SlideShow */
- (NSString *)optionStringAtIndex:(int)rowIndex;
- (NSString *)filenameAtIndex:(int)rowIndex;
- (NSString *)titleAtIndex:(int)rowIndex;
- (BOOL)setOptionString:(NSString *)obj atIndex:(int)rowIndex;

/* NSTableView delegate */
- (BOOL)tableView:(NSTableView *)aTableView shouldEditTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex;

/* NSTableDataSource */
- (int)numberOfRowsInTableView:(NSTableView *)tableView;
- (id)tableView:(NSTableView *)tableView
objectValueForTableColumn:(NSTableColumn *)tableColumn row:(int)row;
- (void)tableView:(NSTableView *)tableView setObjectValue:(id)object forTableColumn:(NSTableColumn *)tableColumn row:(int)row;

@end


@interface ScenarioSource (ActionMethods)

/* Delegate for Editing */
- (void)copy:(id)sender;
- (void)paste:(id)sender;
- (void)cut:(id)sender;
- (void)delete:(id)sender;

@end
