#import  "ColorSampleView.h"
#import  <AppKit/psopsOpenStep.h>
#import  <AppKit/NSImage.h>
#import  <AppKit/NSControl.h>

@implementation ColorSampleView

- (void)dealloc
{
	[bgcolor release];
	[txcolor release];
	[txbgcolor release];
	[transImg release];
	[super dealloc];
}

- (void)setBackgColor:(NSColor *)color
{
	[bgcolor release];
	[(bgcolor = color) retain];
}

- (void)setTextColor:(NSColor *)color
{
	[txcolor release];
	[(txcolor = color) retain];
}

- (void)setTextBgColor:(NSColor *)color andTransparent:(float)val
{
	[txbgcolor release];
	[transImg release];
	if (color == nil) {
		txbgcolor = nil;
		transImg = nil;
	}else {
		NSSize sz;
		[(txbgcolor = color) retain];
		transVal = val;
		sz = [self bounds].size;
		sz.width *= 4.0/6.0;
		sz.height *= 4.0/6.0;
		transImg = [[NSImage alloc] initWithSize:sz];
		[transImg lockFocus];
		[[txbgcolor colorWithAlphaComponent:transVal] set];
		PSrectfill(0.0, 0.0, sz.width, sz.height);
		[transImg unlockFocus];
	}
}

/* Over Write */
- (void)drawRect:(NSRect)r
{
	NSSize sz = [self bounds].size;
	// self is 'lockFocus'ed.
	if (bgcolor == nil)
		return;	/* do nothing */
	[bgcolor set];
	PSrectfill(0.0, 0.0, sz.width, sz.height);
	if (transImg) {
		NSPoint pt;
		pt.x = sz.width / 6.0;
		pt.y = sz.height / 6.0;
		[transImg compositeToPoint:pt operation:NSCompositeSourceOver];
	}
	[txcolor set];
	PSselectfont("Times-Roman", sz.width * 0.4);
	PSmoveto(sz.width / 5.0, sz.height / 2.0);
	PSshow("Aa!");
	PSmoveto(sz.width / 5.0, sz.height / 5.0);
	PSshow("&N");
	PSWait();
}

@end
