#import <Foundation/NSDictionary.h>
#import <AppKit/AppKit.h>
#import <AppKit/NSColor.h>
#import <AppKit/NSFont.h>
#import "dickeys.h"

enum {
	EPS_BG_none = 0,
	EPS_BG_White,
	EPS_BG_Text
};

struct setinfo {
	NSColor *bgcolor;
	NSColor *txcolor;
	NSColor *txbgcolor;
	NSFont	*txfont;
	float	transparent;
	BOOL	usetxbg;
	unsigned char	epsbg;
	unsigned char	baseline;	/* range: 0 - 9 */
	unsigned char	fontsize;	/* range: 1 - 9 */
};

/* function */
struct setinfo *copySetinfo(struct setinfo *info);
void freeSetinfo(struct setinfo *info);
int realFontSize(int fsize);

@class NSInvocation;

@interface SettingDictionary : NSObject
	/* Because NSDictionary is a class-cluster, I can not make this class
	   as a subclass of NSMutableDictionary... */
{
	NSMutableDictionary *dictionary;
	struct setinfo	tmpinfo;  /* temporary area for method setInfo */
}

- (void)dealloc;
/* Message Forwarding */
- (void)forwardInvocation:(NSInvocation *)invocation;

- (id)initWithDictionary:(NSDictionary *)otherDictionary;
- (id)dictionary;

/* Interface with setinfo */
- (id)initWithSettingInfo:(struct setinfo *)info;
- (struct setinfo *)info;

@end
