#import <AppKit/AppKit.h>
#import "PlayControl.h"
#import "sheetInfo.h"
#import "SettingDictionary.h"

#define  QBackward	1
#define  QForward	1
#define  QForwardMax	3
#define  QLength	(QBackward+QForward+1)	/* Prev, Current, and Next */

enum {
	img_Pict, img_EPS, img_Text
};
struct qcell {
	BOOL	skip;
	int	kind;	/* image of TEXT/EPS ? */
	NSImage	*img;
	NSImage	*title;
	opt_t	opt;
};

@class NSImage, NSString, NSLock;

@interface SlideShowCtrl : NSObject <PlayControl>
{
	id	backWin;
	id	backView;
	id	table;
	NSString	*ohpPath;
	NSRect	scrRect;
	int	currentIndex;
	int	sheetNum;
	struct setinfo	*setting;
	struct qcell	**qarray;
	NSLock	*qLock;
	id	quitTarget;
	SEL	quitSel;
}

- (id)init;
- (id)initWithTable:(id)tbl andSetting:(struct setinfo *)info;
- (void)setOHPPath:(NSString *)path;
- (void)setQuitAction:(SEL)sel to:(id)target;
- (void)dealloc;
- (void)startFrom:(int)index;

@end
