#import <AppKit/AppKit.h>

enum {
	TxPlane, TxRTF, TxRTFD, TxImage
};

@class NSColor, NSFont;

@interface TextImageCreator : NSObject
{
	NSColor	*textColor;
	int	baseline;
	int	fontsize;
	NSFont	*currentfont;
}

+ (int)kindOfFile:(NSString *)path;
+ (BOOL)isWrappedFile:(NSString *)fname;
+ (BOOL)isBinaryFile:(NSString *)fname;
+ (NSSize)sizeOfRTF:(NSString *)fname RTFD:(BOOL)isrtfd;
+ (void)setRatioLimit:(float)ratio;
+ (void)setNormalTextViewSize:(NSSize)size;

- (id)init;
- (void)dealloc;
- (void)setTextColor:(NSColor *)color;
- (void)setRaiseBaseline:(int)val;
- (void)setFont:(NSString *)fontname size:(int)size;
- (NSImage *)textImageFrom:(NSString *)textfile;
- (NSImage *)textImageFromString:(NSString *)string;

@end
